Function handleEditor(game.typeGame, sprite.typeSprite)
	If game\timeEvent Then
		xMove = 0
		yMove = 0
		zMove = 0
		angleAmount = 45
		doCreateTile = False

		If KeyDown(gKeySpace) Then
			doCreateTile = True
		End If

		handleEditSubMode game

		If KeyDown(gKeyS) Then
			editorSaveLevel game\level
		End If
		If KeyDown(gKeyL) Then
			editorLoadLevel game\level
		End If

		Select game\editSubMode
			Case gEditPosition
				If KeyDown(gKeyUp) Then
					xMove = -1
				End If
				If KeyDown(gKeyDown) Then
					xMove = 1
				End If
				If KeyDown(gKeyR) Then
					yMove = 1
				End If
				If KeyDown(gKeyF) Then
					yMove = -1
				End If
				If KeyDown(gKeyRight) Then
					zMove = 1
				End If
				If KeyDown(gKeyLeft) Then
					zMove = -1
				End If
		
				moveXYZ sprite, xMove, yMove, zMove

			Case gEditSubClass
				subClassMove = 0
	
				If KeyDown(gKeyRight) Then
					subClassMove = 1
				End If
				If KeyDown(gKeyLeft) Then
					subClassMove = -1
				End If
				
				sprite\subClass = sprite\subClass + subClassMove
				If sprite\subClass > gSubClassMax Then
					sprite\subClass = gSubClassMin
				ElseIf sprite\subClass < gSubClassMin Then
					sprite\subClass = gSubClassMax
				End If
				If subClassMove <> 0 Then
					setTexture sprite, "texture\" + sprite\subClass + ".bmp"
				End If

			Case gEditAngle
				If KeyDown(gKeyLeft) Then
					xMove = angleAmount
				End If
				If KeyDown(gKeyRight) Then
					xMove = -angleAmount
				End If
				If KeyDown(gKeyDown) Then
					zMove = angleAmount
				End If
				If KeyDown(gKeyUp) Then
					zMove = -angleAmount
				End If
	
				moveAngleXYZ sprite, xMove, yMove, zMove
			
			Case gEditScale
				If KeyDown(gKeyUp) Then
					xMove = 1
				End If
				If KeyDown(gKeyDown) Then
					xMove = -1
				End If
				If KeyDown(gKeyR) Then
					yMove = 1
				End If
				If KeyDown(gKeyF) Then
					yMove = -1
				End If
				If KeyDown(gKeyRight) Then
					zMove = 1
				End If
				If KeyDown(gKeyLeft) Then
					zMove = -1
				End If
	
				moveScaleXYZ sprite, xMove, yMove, zMove
		End Select
		
		If doCreateTile Then
			If Not spriteExistsByReference(sprite, classTile) Then
				createTile sprite
			End If
		End If
		
	End If
End Function

Function spriteExistsByReference(reference.typeSprite, referenceClass)
	sameSpriteFound = False
	
	For sprite.typeSprite = Each typeSprite
		If sprite\class = referenceClass Then
			isSameX = False
			isSameY = False
			isSameZ = False
			
			For d = dMin To dMax
				samePosition = (sprite\position#[d] = reference\position#[d])
				sameScale = (sprite\scale#[d] = reference\scale#[d])
				sameAngle = (sprite\angle#[d] = reference\angle#[d])
				sameSubClass = (sprite\subClass = reference\subClass)
				If samePosition And sameScale And sameAngle And sameSubClass Then
					If d = dX Then isSameX = True
					If d = dY Then isSameY = True
					If d = dZ Then isSameZ = True
				End If
			Next
			
			sameSpriteFound = isSameX And isSameY And isSameZ
			If sameSpriteFound Then
				Exit
			End If
			
		End If
	Next
	
	Return sameSpriteFound
End Function

Function editorSaveLevel(level)
	file = WriteFile("level1\tiles" + level + ".dat")
	For sprite.typeSprite = Each typeSprite
		If sprite\class = classTile Then
			For d = dMin To dMax
				WriteFloat file, sprite\position#[d]
				WriteFloat file, sprite\scale#[d]
				WriteFloat file, sprite\angle#[d]
			Next
			WriteInt file, sprite\subClass
		End If
	Next
	CloseFile file
End Function

Function editorLoadLevel(level)
	file = ReadFile("level1\tiles" + level + ".dat")
	While Not Eof(file)
		sprite.typeSprite = New typeSprite
		For d = dMin To dMax
			sprite\position#[d] = ReadFloat(file)
			sprite\scale#[d] = ReadFloat(file)
			sprite\angle#[d] = ReadFloat(file)
		Next
		sprite\subClass = ReadInt(file)
		createTile sprite
		Delete sprite
	Wend
	CloseFile file
End Function

Function getVerboseEditSubMode$(editSubMode)
	verbose$ = ""

	Select editSubMode
		Case gEditPosition
			verbose$ = "Position"
		Case gEditScale
			verbose$ = "Scale"
		Case gEditAngle
			verbose$ = "Angle"
		Case gEditSubClass
			verbose$ = "Sub-Class"
	End Select
	
	Return verbose$
End Function

Function handleEditSubMode(game.typeGame)
	If KeyDown(gKeyF1) Then
		game\editSubMode = 1
	ElseIf KeyDown(gKeyF2) Then
		game\editSubMode = 2
	ElseIf KeyDown(gKeyF3) Then
		game\editSubMode = 3
	ElseIf KeyDown(gKeyF4) Then
		game\editSubMode = 4
	EndIf
	
	If game\editSubMode < gEditMin Or game\editSubMode > gEditMax Then
		game\editSubMode = gEditMin
	End If

	message$ = "Edit-Mode: "
	For i = gEditMin To gEditMax
		If game\editSubMode = i Then
			crossed$ = "X"
		Else
			crossed$ = " "
		End If
		message$ = message$ + "    [" + crossed$ + "] "	
		message$ = message$ + "F" + Str$(i) + " "
		message$ = message$ + getVerboseEditSubMode$(i)
	Next
	sendMessage message$
End Function