Function handleClass(game.typeGame, sprite.typeSprite)
	Select sprite\class
		Case classPlayer
			If Not game\editMode Then
				handlePlayer sprite
			End If
		Case classEditor
			handleEditor game, sprite
		Case classTerrain
			handleTerrain sprite
		Case classTile
			handleTile sprite
		Case classBackground
			handleClassBackground sprite
	End Select
End Function

Function handleTile(sprite.typeSprite)
	If sprite\subClass = 0 Then
		If reachedAngleTarget(sprite) Then
			If Rnd(10) > 8 Then
				moveAngleTargetXYZ sprite, 180, 90, 0
			Else
				moveAngleTargetXYZ sprite, 0, 90, 0
			End If
		End If
	End If
End Function

Function handleClassBackground(sprite.typeSprite)
	If reachedAngleTarget(sprite) Then
		moveAngleTargetXYZ sprite, 0, 90, 0
	End If
End Function

Function handleTerrain(sprite.typeSprite)
	max# = .5
	change# = .01
	changeDouble# = change# * 2

	If sprite\timeEvent Then
		For x = 1 To gTerrainSize
			For z = 1 To gTerrainSize
				If Rnd(10) >= 9 Then
					height# = TerrainHeight(sprite\body, x, z)
					height# = height# + ( ( Rnd(1) * change# ) -changeDouble# )
					If height# > max# Then
						height# = max#
					ElseIf height# < -max# Then
						height# = -max#
					End If
					ModifyTerrain sprite\body, x, z, height#
				End If
			Next
		Next
	End If
End Function

Function handlePlayer(sprite.typeSprite)
	xMove# = 0
	yMove# = 0
	zMove# = 0

	If KeyDown(gKeyUp) Then
		xMove# = -1
	End If
	If KeyDown(gKeyDown) Then
		xMove# = 1
	End If
	If KeyDown(gKeySpace) Then
		yMove# = 1
	End If
	If KeyDown(gKeyRight) Then
		zMove# = 1
	End If
	If KeyDown(gKeyLeft) Then
		zMove# = -1
	End If

	If xMove <> 0 Or zMove <> 0 Or yMove <> 0 Then
		setSpriteColorTargetAll sprite, 195
		sprite\speed#[dX] = sprite\speed#[dX] + xMove# * sprite\speedStep#[dX]
		If yMove# <> 0 And sprite\didCollide[dY] Then
			sprite\speed#[dY] = sprite\speed#[dY] + yMove# * 2
			soundEffect "ping"
		End If
		sprite\speed#[dZ] = sprite\speed#[dZ] + zMove# * sprite\speedStep#[dZ]
	Else
		setSpriteColorTargetAll sprite, paletteMax - 30
	End If
	
	RotateEntity sprite\body, sprite\speed#[dZ] * 150, 0, -sprite\speed#[dX] * 150

	If sprite\timeEvent Then
		If getSpriteTopSpeed#(sprite) > .7 Then
			createPlayershade sprite
		End If
	End If

	If sprite\position#[dY] < -9 And sprite\energyDirection >= 0 Then
		createExplosion sprite
		For i = 1 To 30
			createParticle sprite\position#[dX] + .2, sprite\position#[dY] + 1, sprite\position#[dZ] + .8, True, True
		Next
		sprite\energyDirection = -1
	End If
	
	;particleMax = getSpriteTopSpeed#(sprite) * 10
	;For i = 1 To particleMax
	;	createParticle sprite
	;Next
End Function